#include <fstream>

///
using namespace std;

/// Eine einfache Klasse fr Punkte im R^3
class Point3D
{ 
  public:
  ///
  float x;
  ///
  float y;
  ///
  float z;
  
  ///
  friend bool operator< (const Point3D& p,const Point3D& q)
  { 
    if (p.x < q.x) return true;
    if (p.x > q.x) return false;
    if (p.y < q.y) return true;
    if (p.y > q.y) return false;
    if (p.z < q.z) return true;
    return false;
  }
  ///
  friend istream& operator>> (istream& is, Point3D& p)
  {
    is >> p.x >> p.y >> p.z; 
    return is;
  }

  ///
  friend ostream& operator<< (ostream& os, const Point3D& p)
  {
    os << p.x << "  " << p.y << " " << p.z;
    return os;
  }
};

class Triangle
{ 
  public:

  Point3D a,b,c;

  friend istream& operator>> (istream& is, Triangle& triangle)
  {
    is >> triangle.a >> triangle.b >> triangle.c;
    return is;
  }

  friend ostream& operator<< (ostream& os, const Triangle& triangle)
  {
    os << triangle.a << " " <<  triangle.b << " " << triangle.c << endl;
    return os;
  }

};

/** Eine Klasse zur Berechnung von umschlieenden Rechtecken 
    fr Punktmengen
*/
class BoundingBox3D
{
  public:

  /// linke untere Ecke
  Point3D min;
  /// rechte obere Ecke
  Point3D max;

  ///
  BoundingBox3D()
  {
    min.x = min.y = min.z =  1e10;
    max.x = max.y = max.z = -1e10;
  }

  /// gibt die Bounding Box aus 
  friend ostream& operator<< (ostream& os, const BoundingBox3D& bb)
  {
    os << "[" << bb.min.x << "," << bb.max.x << "]" 
       << " x [" << bb.min.y << "," << bb.max.y << "]"
       << " x [" << bb.min.z << "," << bb.max.z << "]";
    return os;
  }
}///
;

class EnlargeBB3D
{
  public:
    EnlargeBB3D( BoundingBox3D& b) : bb(b) {}

    void operator()(const Point3D& p)
    {
      if (p.x < bb.min.x) bb.min.x = p.x;
      if (p.y < bb.min.y) bb.min.y = p.y;
      if (p.z < bb.min.z) bb.min.z = p.z;
      if (p.x > bb.max.x) bb.max.x = p.x;
      if (p.y > bb.max.y) bb.max.y = p.y;
      if (p.z > bb.max.z) bb.max.z = p.z;
    }

    void operator()(const Triangle& t)
    {
      operator()(t.a);
      operator()(t.b);
      operator()(t.c);
    }

  private:
    BoundingBox3D& bb;
};

