#include <string>
#include "RasterData.h"

istream& operator>> (istream& is, RasterData& data)
{
  string s;
  int    i,j,value;

  is >> s;
  if (s != "ncols") return is;
  is >> data.ncols;
  is >> s;
  if (s != "nrows") return is;
  is >> data.nrows;
  is >> s;
  if (s != "xllcorner") return is;
  is >> data.xllcorner;
  is >> s;
  if (s != "yllcorner") return is;
  is >> data.yllcorner;
  is >> s;
  if (s != "cellsize") return is;
  is >> data.cellsize;
  is >> s;
  if (s != "NODATA_value") return is;
  is >> data.NODATA_value;

  data.Image = new GLubyte[data.nrows*data.ncols];

  for(i=0;i<data.nrows;i++)
    for(j=0;j<data.ncols;j++)
    { 
      is >> value;
      if (value == data.NODATA_value) value = 0;
      data.Image[(data.nrows-1-i)*data.ncols+j] = GLubyte(value >> 2);
    }

  return is;
}

ostream& operator<< (ostream& os, const RasterData& data)
{
  os << "ncols = " << data.ncols << endl;
  os << "nrows = " << data.nrows << endl;
  os << "xllcorner = " << data.xllcorner << endl;
  os << "yllcorner = " << data.yllcorner << endl;
  os << "cellsize = " << data.cellsize << endl;
  os << "NODATA_value = " << data.NODATA_value << endl;
  os << "first value = " << int(data.Image[0]) << endl;
  os << "last value = " << int(data.Image[data.ncols*data.nrows-1]) 
     << endl;

  return os;
}

void RasterData::subImage(int width,int height,int offsetX,int offsetY,GLubyte *subimage)
{
  GLubyte value;
  int     x,y;

  for(y=0;y<height;y++)
    for(x=0;x<width;x++)
    { if (offsetX+x < 0) value = 0; else
      if (offsetX+x >= ncols) value = 0; else
      if (offsetY+y < 0) value = 0; else
      if (offsetY+y >= nrows) value = 0; else
      value = Image[ncols*(offsetY+y)+offsetX+x];
      subimage[y*width+x] = value;
    }
}

void RasterData::normal(int x,int y,float *n)

{ 
  if (x == 0) n[0] = (*this)(1,y)-(*this)(0,y);
  else if (x == ncols-1) n[0] = (*this)(ncols-1,y)-(*this)(ncols-2,y);
  else n[0] = 0.5*((*this)(x+1,y)-(*this)(x-1,y));

  if (y == 0) n[1] = (*this)(x,1)-(*this)(x,0);
  else if (y == nrows-1) n[1] = (*this)(x,nrows-1)-(*this)(x,nrows-2);
  else n[1] = 0.5*((*this)(x,y+1)-(*this)(x,y-1));

  n[2] = cellsize/20.0;
  
/*
  float l = (float) sqrt(n[0]*n[0]+n[1]*n[1]+n[2]*n[2]);
  n[0] /= l;
  n[1] /= l;
  n[2] /= l;
*/
}
